<template>
    <div v-if="popup">
        <div class="full-width form-inline edit__set_block white-space">
            <h4>Pop Up Name</h4>
            <br>
            <validation-element
                id="name"
                v-model="popup.name"
                label="Name"
                custom-input-class="my-input full-width"
                custom-label-class="label_light"
            />
        </div>
        <div class="full-width form-inline edit__set_block white-space">
            <h4 class="mb-md-4">
                Pop Up Design
            </h4>
            <br>
            <div class="row mb-md-4">
                <div class="col-12 mb-2 col-md-6">
                    <div
                        class="text-bold title-text"
                    >
                        Pop Up Background
                    </div>
                    <b-select
                        id="popup_background_type"
                        v-model="popup.popup_background_type"
                        style="background-color: white;"
                        type="text"
                        class="my-select-menu full-width"
                    >
                        <option value="1">
                            Solid Color
                        </option>
                        <option value="2">
                            Image
                        </option>
                    </b-select>
                </div>

                <div
                    v-show="popup.popup_background_type==1"
                    class="col-12 mb-2 col-md-6 align-items-end"
                    :class="{'d-flex': popup.popup_background_type==1}"
                >
                    <div class="full-width">
                        <div class="title-text">
                            Background Color
                        </div>
                        <div class="jscolor-group">
                            <b-form-input
                                id="background-color"
                                v-model="popup.colors.settings_background"
                                data-vv-as="Header Color"
                                type="text"
                                class="my-input full-width"
                            />
                            <button
                                :style="{background: popup.colors.settings_background}"
                                class="btn btn-color"
                                type="button"
                                @click="showPicker('background')"
                            />

                            <div
                                v-show="background.active"
                                class="chrome-picker"
                            >
                                <chrome-picker v-model="backgroundColor" />
                            </div>
                        </div>
                    </div>
                </div>
                <div
                    v-show="popup.popup_background_type==2"
                    class="col-12 mb-2 col-md-6 align-items-end"
                    :class="{'d-flex': popup.popup_background_type==2}"
                >
                    <button
                        type="button"
                        class="btn btn-primary mt-0 full-width btn-upload"
                        @click="$refs.backgroundUpload.click()"
                    >
                        <!--                        <svg xmlns="http://www.w3.org/2000/svg" style="margin-right: 10px" width="18" height="18"-->
                        <!--                             viewBox="0 0 18 18">-->
                        <!--                            <path id="icons8-upload" d="M11,2,5.6,7.4H9.2V16h3.6V7.4h3.6ZM2,18.2V20H20V18.2Z"-->
                        <!--                                  transform="translate(-2 -2)" fill="#fff"/>-->
                        <!--                        </svg>-->

                        Upload Background Image
                    </button>
                    <input
                        v-show="false"
                        ref="backgroundUpload"
                        type="file"
                        @change="imageUpload('background')" 
                    >
                </div>
            </div>

            <div class="full-width mb-2 mb-md-4">
                <div class="full-width">
                    <validation-element
                        id="paragraph-1"
                        v-model="popup.title"
                        type="textarea"
                        label="Pop Up Title"
                        data-vv-as="Body Text"
                        name="paragraph_1"
                        rows="4"
                        custom-input-class="my-text-area"
                        custom-label-class="text-bold label_light"
                    />
                </div>
            </div>
            <div class="row mb-2 mb-md-4">
                <div class="col-md-12">
                    <!-- <div class="text-bold title-text label_light">
                        Pop Up Title Size
                    </div> -->
                    <validation-element
                        id="title-size"
                        v-model="popup.title_size"
                        label="Pop Up Title Size"
                        input-type="number"
                        min="2"
                        max="40"
                        data-vv-as="Body Text"
                        custom-label-class="text-bold label_light"
                    />
                </div>
            </div>
            <div class="row mb-md-4">
                <div class="col-12 mb-2 col-md-6">
                    <div class="full-width">
                        <div class="title-text">
                            Pop Up Title Text
                        </div>
                        <div class="jscolor-group">
                            <b-form-input
                                id="settings-title-color"
                                v-model="popup.colors.settings_title"
                                data-vv-as="Header Color"
                                type="text"
                                class="my-input full-width"
                            />
                            <button
                                :style="{background: popup.colors.settings_title}"
                                class="btn btn-color"
                                type="button"
                                @click="showPicker('title')"
                            />

                            <div
                                v-show="title.active"
                                class="chrome-picker"
                            >
                                <chrome-picker v-model="titleColor" />
                            </div>
                        </div>
                    </div>
                </div>
                <div
                    v-if="!showNewModal"
                    class="col-12 mb-2 col-md-6"
                >
                    <div class="text-bold title-text">
                        Pop Up Style
                    </div>
                    <b-select
                        id="popup_style"
                        v-model="popup.popup_style"
                        style="background-color: white;"
                        type="text"
                        class="my-select-menu full-width"
                    >
                        <option value="1">
                            Style 1
                        </option>
                        <option value="2">
                            Style 2
                        </option>
                    </b-select>
                </div>
            </div>
            <div class="row mb-2 mb-md-4">
                <div class="col-md-12">
                    <!-- <div class="text-bold title-text label_light">
                        Pop Up Title Size
                    </div> -->
                    <validation-element
                        id="title-size"
                        v-model="popup.copied_toast_text"
                        label="Copied Toast Text"
                        min="2"
                        max="40"
                        data-vv-as="Body Text"
                        custom-label-class="text-bold label_light"
                    />
                </div>
            </div>
            <div class="full-width">
                <div
                    v-if="popup.popup_style == 1"
                    class="row mb-md-4"
                >
                    <div class="col-12 mb-2 col-md-6">
                        <div class="full-width">
                            <div class="title-text">
                                Progress Bar Color
                            </div>
                            <div class="jscolor-group">
                                <b-form-input
                                    id="progress-bar-color"
                                    v-model="popup.colors.progress_bar_color"
                                    data-vv-as="Arrow Color"
                                    type="text"
                                    class="my-input full-width"
                                />
                                <button
                                    :style="{background: popup.colors.progress_bar_color}"
                                    class="btn btn-color"
                                    type="button"
                                    @click="showPicker('progressBar')"
                                />

                                <div
                                    v-show="progressBar.active"
                                    class="chrome-picker"
                                >
                                    <chrome-picker v-model="progressBarColor" />
                                </div>
                            </div>
                        </div>
                    </div>
                    <div
                        v-if="previewType.type===1 && !showNewModal"
                        class="col-md-6"
                    >
                        <div class="full-width">
                            <div class="title-text">
                                Arrow Background Color
                            </div>
                            <div class="jscolor-group">
                                <b-form-input
                                    id="arrow-colors"
                                    v-model="popup.colors.arrow_color"
                                    data-vv-as="Arrow Color"
                                    type="text"
                                    class="my-input full-width"
                                />
                                <button
                                    :style="{background: popup.colors.arrow_color}"
                                    class="btn btn-color"
                                    type="button"
                                    @click="showPicker('arrow')"
                                />

                                <div
                                    v-show="arrow.active"
                                    class="chrome-picker"
                                >
                                    <chrome-picker v-model="arrowColor" />
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div
                v-if="!showNewModal"
                class="full-width"
            >
                <div
                    v-if="popup.popup_style == 2"
                    class="row mb-md-4"
                >
                    <div class="col-md-6">
                        <div class="full-width">
                            <div class="title-text">
                                Arrow Background Color
                            </div>
                            <div class="jscolor-group">
                                <b-form-input
                                    id="arrow-color"
                                    v-model="popup.colors.arrow_color"
                                    data-vv-as="Arrow Color"
                                    type="text"
                                    class="my-input full-width"
                                />
                                <button
                                    :style="{background: popup.colors.arrow_color}"
                                    class="btn btn-color"
                                    type="button"
                                    @click="showPicker('arrow')"
                                />

                                <div
                                    v-show="arrow.active"
                                    class="chrome-picker"
                                >
                                    <chrome-picker v-model="arrowColor" />
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div
                v-if="!showNewModal"
                class="full-width"
            >
                <div class="row mb-md-4">
                    <div class="col-12 mb-2 col-md-6">
                        <div class="text-bold title-text">
                            Icon Style
                        </div>
                        <b-select
                            id="icon_style"
                            v-model="popup.icon_style"
                            style="background-color: white;"
                            type="text"
                            class="my-select-menu full-width"
                        >
                            <option value="1">
                                Style 1
                            </option>
                            <option value="2">
                                Style 2
                            </option>
                            <option value="3">
                                Style 3
                            </option>
                            <option value="4">
                                Custom
                            </option>
                        </b-select>
                    </div>
                </div>
            </div>
            <div
                v-if="showNewModal && brandLogo.show"
                class="full-width"
            >
                Carti branding
                <b-form-checkbox
                    id="checkbox-1"
                    v-model="popup.hide_branding"
                    name="checkbox-1"
            
                    @change="showModalCartiBranding = true"
                >
                    {{ $cookies.get('platform') == 'shopify' ? 'Remove Carti branding for 1$ (monthly)' : 'Remove Carti branding for 5$ (one-time payment)' }}
                </b-form-checkbox>
            </div>
            <div class="full-width">
                <div
                    v-if="popup.icon_style == 4"
                    class="row"
                >
                    <div class="col-12 mb-2 col-md-5">
                        <button
                            type="button"
                            class="btn btn-primary full-width btn-upload"
                            @click="$refs.popupUpload.click()"
                        >
                            <svg
                                xmlns="http://www.w3.org/2000/svg"
                                style="margin-right: 10px"
                                width="18"
                                height="18"
                                viewBox="0 0 18 18"
                            >
                                <path
                                    id="icons8-upload"
                                    d="M11,2,5.6,7.4H9.2V16h3.6V7.4h3.6ZM2,18.2V20H20V18.2Z"
                                    transform="translate(-2 -2)"
                                    fill="#fff" 
                                />
                            </svg>
                            Close Icon State
                        </button>
                    </div>
                    <input
                        v-show="false"
                        ref="popupUpload"
                        type="file"
                        @change="imageUpload('popup')"
                    >
                    <div class="col-12 mb-2 col-md-2">
                        <button
                            type="button"
                            class="btn btn-danger full-width btn-upload"
                            @click="popup.popup_image_closed=''"
                        >
                            <svg
                                xmlns="http://www.w3.org/2000/svg"
                                width="12"
                                height="12"
                                viewBox="0 0 12 12"
                            >
                                <path
                                    id="icons8-multiply"
                                    d="M5.394,4.293l-1.1,1.1,4.9,4.9-4.9,4.9,1.1,1.1,4.9-4.9,4.9,4.9,1.1-1.1-4.9-4.9,2.174-2.174,2.725-2.725-1.1-1.1-4.9,4.9Z"
                                    transform="translate(-4.293 -4.293)"
                                    fill="#0c0c0c" 
                                />
                            </svg>
                        </button>
                    </div>
                </div>
            </div>
            <div class="full-width">
                <div
                    v-if="popup.icon_style == 4"
                    class="row"
                >
                    <div class="col-12 mb-2 col-md-5">
                        <button
                            type="button"
                            class="btn btn-primary full-width btn-upload"
                            @click="$refs.popupOpenUpload.click()"
                        >
                            <svg
                                xmlns="http://www.w3.org/2000/svg"
                                style="margin-right: 10px"
                                width="18"
                                height="18"
                                viewBox="0 0 18 18"
                            >
                                <path
                                    id="icons8-upload"
                                    d="M11,2,5.6,7.4H9.2V16h3.6V7.4h3.6ZM2,18.2V20H20V18.2Z"
                                    transform="translate(-2 -2)"
                                    fill="#fff" 
                                />
                            </svg>
                            Open Icon State
                        </button>
                    </div>
                    <input
                        v-show="false"
                        ref="popupOpenUpload"
                        type="file"
                        @change="imageUpload('popup-open')"
                    >
                    <div class="col-12 mb-2 col-md-2">
                        <button
                            class="btn btn-danger full-width btn-upload"
                            @click="popup.popup_image=''"
                        >
                            <svg
                                xmlns="http://www.w3.org/2000/svg"
                                width="12"
                                height="12"
                                viewBox="0 0 12 12"
                            >
                                <path
                                    id="icons8-multiply"
                                    d="M5.394,4.293l-1.1,1.1,4.9,4.9-4.9,4.9,1.1,1.1,4.9-4.9,4.9,4.9,1.1-1.1-4.9-4.9,2.174-2.174,2.725-2.725-1.1-1.1-4.9,4.9Z"
                                    transform="translate(-4.293 -4.293)"
                                    fill="#0c0c0c" 
                                />
                            </svg>
                        </button>
                    </div>
                </div>
            </div>
        </div>
        <ModalConfirm
            custom-class="modal_carti_branding"
            :show="showModalCartiBranding"
            title="Remove the Carti branding"
            :loading="brandLogo.loading"
            desc="This will remove the Carti branding from the Growth Tool popup. 1$ will be charged monthly from your account"
            @confirm="confirmBrandLogo"
            @close="closeModalConfirm(), popup.hide_branding = false"
        />
    </div>
</template>

<script>
import {Chrome} from 'vue-color';
import api from '../../services/growth-tools.service'
// import ValidationElement from '@/components/elements/ValidationElement'
import ValidationElement from '../elements/ValidationElement.vue';
import ModalConfirm from '@/components/testing-elements/pricing/ModalConfirm'
import { ajaxGet, ajaxPost } from '../../helpers/ajax';

export default {
    name: "PopupSettings",
    components: {
        'chrome-picker': Chrome,
        // ValidationElement,
        ValidationElement,
        ModalConfirm,
    },
    props: {
        popup: Object,
        previewType: Object,
        showNewModal: Boolean,
    },
    data() {
        return {
            progressBar: {active: false},
            arrow: {active: false},
            background: {active: false},
            title: {active: false},
            backgroundColor: '',
            titleColor: '',
            arrowColor: '',
            progressBarColor: '',
            brandLogo: {
                status: false,
                show: true,
                loading: false,
            },
            showModalCartiBranding: false,
        }
    },
    watch: {
        backgroundColor: {
            deep: true,
            handler() {
                this.popup.colors.settings_background = this.backgroundColor.hex;
            }
        },
        arrowColor: {
            deep: true,
            handler() {
                this.popup.colors.arrow_color = this.arrowColor.hex;
            }
        },
        titleColor: {
            deep: true,
            handler() {
                this.popup.colors.settings_title = this.titleColor.hex;
            }
        },
        progressBarColor: {
            deep: true,
            handler() {
                this.popup.colors.progress_bar_color = this.progressBarColor.hex;
            }
        }
    },
    created() {
        this.checkStatusBrandLogo()
    },
    methods: {
        async confirmBrandLogo() {
          this.brandLogo.loading = true
          const isShopify = this.$cookies.get('platform') == 'shopify'
          if(isShopify) {
             ajaxPost('/shop/hide-branding', {}, 'user') 
          } else {
            const data = await ajaxGet('/checkout-branding-url', {}, 'user')  
            window.open(data)
          }
          this.hideBrandLogo()
        },
        async hideBrandLogo() {
            this.brandLogo.show = false
            this.closeModalConfirm()
        },
        closeModalConfirm() {
            this.showModalCartiBranding = false
        },
        checkStatusBrandLogo() {
            this.brandLogo.show = !this.popup.hide_branding
        },
        async imageUpload(type) {
            const formData = new FormData();
            let file 
            if (type === 'background') {
                file = this.$refs.backgroundUpload.files[0];
            } else if (type === 'popup-open') {
                file = this.$refs.popupOpenUpload.files[0];
            } else {
                file = this.$refs.popupUpload.files[0];
            }
            if(file.size >= 4000000) {
                this.$notify({
                    type: 'error',
                    title: 'Upload Max File Size 4M',
                })
                return
            }
            formData.append('type', type)
            formData.append("file", file)
            try {
                await api.imageUpload(type, this.popup.id, formData)
            } catch(err) {
                console.log(err, 'errr')
                return 
            }
            
            const img = URL.createObjectURL(file);

            switch(type) {
                case 'background': {
                    this.popup.background_image = img
                    break
                }
                case 'popup': {
                    this.popup.popup_image_closed = img
                    break
                }
                default: {
                    this.popup.popup_image = img
                }
            }
        },
        showPicker(val) {
            this.hidePicker();
            document.addEventListener('click', this.documentClick);

            this[val].active = true;
        },
        hidePicker() {
            document.removeEventListener('click', this.documentClick);
            this.progressBar.active = false
            this.arrow.active = false;
            this.background.active = false;
            this.title.active = false;
        },
        documentClick(e) {
            if (e.target.className.indexOf('btn-color') === -1 && e.target.className.substr(0, 2) !== 'vc') {
                this.hidePicker()
            }
        },
    }
}
</script>

<style scoped lang="scss">

.my-select-menu {
    height: 40px;
}

.btn-upload {
    padding: 6px 7px !important;
    margin-top: 32px;
    font-size: 12px;
    display: flex;
    height: 40px;
    justify-content: center;
    align-items: center;
}

.jscolor-group {
    max-width: 100%;
}
// .checkbox {
//     margin-top: 12px;
//     display: flex;
//     align-items: flex-start;
//     input {
//         border: 1px solid #DAE7FF;
//         width: 24px;
//         height: 24px;
//     }
//     label {
//         display: inline-block;
//         margin-left: 10px;
//         font-size: 14px;
//         line-height: 140%;
//     }
// }
::v-deep {
    .custom-control {
        padding-left: 30px;
        margin-top: 7px;
        &-input,
        &-label::after,
        &-label::before {
            width: 24px;
            height: 24px;
        }
        &-label {
            &::after, &::before {
                left: -30px;
                top: 0;
            }
            &::before {
                border-color: #DAE7FF;
            }
        }
    }
    .form-inline label {
        font-size: 14px;
        line-height: 140%;
        justify-content: flex-start;
        padding-top: 3px;
    }
}

</style>


<style lang="scss">
.modal_carti_branding.modal-content{
    width: 345px;
    .desc {
        text-align: center;
        padding: 0 24px;
        font-size: 14px;
        line-height: 160%;
        text-align: center;
        color: #6D7378;
    }
    .popup-header-text {
        padding-top: 21px;
    }
}
</style>